<?
$LEVEL=10;
include_once("../common.php");
include_once("services.php");
include_once("firewall.php");
include_once("ipblocks.php");
include_once("../form.php");
include_once("../settings/settings.php");
require_once("../error.php");

//input or forwarding mode? Non-internet servers can only do input mode
if (! ModuleMatch("I") || $_REQUEST[mode]=="input")
	$mode="input";
else
	$mode="forward";


///////////////////set the new_ values
//is there a name of an existing entry specified?
$ruletxt=$_REQUEST['ruletxt'];
if (isset($ruletxt))
{
	$rules=firewall_Read();
	$rule=$rules[$ruletxt];
	$new_dstserviceandtype="$rule[dstservicetype]!$rule[dstservice]";
	$new_dsttype=$rule[dsttype];
	$new_dst=$rule[dst];
	$new_srctype=$rule[srctype];
	$new_src=$rule[src];
	$new_access=$rule[access];
	$new_fwdhost=$rule[fwdhost];

	list($dstservicetype,$dstservice)=explode("!",$new_dstserviceandtype);
	list($tmpport,$proto)=explode("/",$dstservice);
	list($port,$toport)=explode("-",$tmpport);


	//If forward port range, then fill select box else input field.
	if($new_access=="pat" && $toport!="")
		$new_fwdports=$rule[fwdport];
	else
		$new_fwdport=$rule[fwdport];

	$iptableserror=IptablesReadError($ruletxt);
	Title(_ChangingFirewallRule());
}
else
{
	Title(_CreatingNewFirewallRule());
}

//overwrite new_ values with posted values
OverwriteNewVars();

///////////////////validate new_ values


//if source is internet, then destination ALWAYS is this server
if ($new_srctype=="zone_INET")
{
	$new_dsttype="zone_FW";
}

$allowed_accessmodes=$ACCESSMODES;
$src_hosttypes=$HOSTTYPES;
$dst_hosttypes=$HOSTTYPES;

//in input mode, we dont have pat and only have zone_fw as destination
if ($mode=="input")
{
 	$new_dsttype="zone_FW";
	unset($allowed_accessmodes[pat]);
}


//setting output from firewall isn't allowed since it's
//only confusing. (output is always allowed fully)
unset($src_hosttypes['zone_FW']);

//only source mac filtering for now
unset($dst_hosttypes[mac_adres]);


//pat only allowed when:
//  source is INET AND dst is firewall
//  OR dst is firewall
//  OR dst is ipblock
if (
	!(
		(
			($new_srctype=="zone_INET")
			&& ($new_dsttype=="zone_FW")
		)
		|| ($new_dsttype=="ipadress")
		|| ($new_dsttype=="ipblock")
	)
)
{
	unset($allowed_accessmodes[pat]);
}

function CheckHost($hosttype,$host)
{
	if (($hosttype=="ipblock") && (!$host))
	{
		return(_SelectIpblock());
	}
	elseif (($hosttype=="ipadress") && ($err=Error_ValidIp($host)))
	{
		return($err);
	}
	elseif (($hosttype=="hostname") && ($err=Error_ValidHostname($host)))
	{
		return($err);
	}
	elseif (($hosttype=="mac_adres") && ($err=Error_ValidMac($host)))
	{
		return($err);
	}
	elseif (($hosttype=="bridgeport") && (!$host))
	{
		return(_SelectBridgePort());
	}
	elseif (($hosttype=="openvpn_cert") && (!$host))
	{
		return(_SelectOpenVPNCertifcate());
	}
}

if (!$new_dstserviceandtype)
{
	$errors[new_dstserviceandtype]=_SelectAService();
}
elseif(!$new_srctype)
{
	$errors[new_srctype]=_SelectHostType();
}
elseif ($err=CheckHost($new_srctype,$new_src))
{
	$errors[new_src]=$err;
}
elseif (!$new_dsttype)
{
	$errors[new_dsttype]=_SelectHostType();
}
elseif ($err=CheckHost($new_dsttype,$new_dst))
{
	$errors[new_dst]=$err;
}
elseif ((strstr($new_dsttype,"zone_") && ($new_dsttype==$new_srctype)))
{
	$errors[new_dsttype]=_SourceZoneCantBeDstZone();
}
elseif(!$new_access)
{
	$errors[new_access]=_SelectAccessMode();
}
elseif ($new_access=="pat")
{
	//for PAT we need to check extra stuff
	list($dstservicetype,$dstservice)=explode("!",$new_dstserviceandtype);
	list($tmpport,$proto)=explode("/",$dstservice);
	list($port,$toport)=explode("-",$tmpport);
	if (
		($dstservicetype!='service') ||
		($proto!="tcp" && $proto!="udp") ||
		(!$port)
	)
	{
		//PAT only works with a single tcp or udp service
		$errors[new_dstserviceandtype]=_PATneedsTcpOrUdpService();
	}
	elseif ($err=Error_ValidIp($new_fwdhost))
	{
		$errors[new_fwdhost]=$err;
	}
	elseif ($toport=="" && $err=Error_ValidPort($new_fwdport))
	{
		$errors[new_fwdport]=$err;
	}
	elseif($toport!="" && $new_fwdports=="")
	{
		$errors[new_fwdports]=_SelectPortRange();
	}

	//unset new old new vars
	if($toport=="")
		unset($GLOBALS['new_fwdports']);
}


////////////////////save new_ values?
if (!$errors && $_REQUEST[save])
{

	list($dstservicetype,$dstservice)=explode("!",$new_dstserviceandtype);
	$newrule[dstservice]=$dstservice;
	$newrule[dstservicetype]=$dstservicetype;
	$newrule[dsttype]=$new_dsttype;
	$newrule[dst]=$new_dst;
	$newrule[srctype]=$new_srctype;
	$newrule[src]=$new_src;
	$newrule[access]=$new_access;
	$newrule[fwdhost]=$new_fwdhost;
	if($new_fwdports!="")
		$newrule[fwdport]=$new_fwdports;
	else
		$newrule[fwdport]=$new_fwdport;
	if (isset($new_enabled))
		$newrule[enabled]=$new_enabled;
	else
		$newrule[enabled]=1;
	ChangeRule($ruletxt,$newrule);
	Redirect($PREV_URI);
}

//////////////////////delete entry?
if ($_REQUEST[del])
{
	ChangeRule($ruletxt,null);
	Redirect($PREV_URI);
};


///////////////////Html code
?>

<? Head($errors); ?>

<? FormStart($TITLE);

	$bridgeportselect=GetBridges();
	$openvpnselect=GetOpenVPNCerts();

	//transform for selectbox
	foreach($IPBLOCKS as $name=>$block)
	{
		$ipblocksselect[$name]="$name [$block]";
	}

	echo "<table class='ctrlgroup'><tr><td>";
	echo _UseOf();

	//determine services and servicegroups
	$services=services_Read();
	foreach ($services as $service=>$data)
	{
		list($port,$proto)=explode("/",$service);
		$servicetmp[$service]="$data[desc] [ $port/".$PROTOS[$proto]." ]";
		//the service belongs to a group?
		if ($data['group']!='')
		{
			//new group?
			if (!$grouptmp[$data['group']])
			{
				$grouptmp[$data['group']]="$data[group] [ ";
			}
			$grouptmp[$data['group']].="$port/$PROTOS[$proto] ";
		}
	}

	//sort them
	natcasesort($grouptmp);
	natcasesort($servicetmp);

	//merge services and service groups
	foreach ($grouptmp as $groupname=>$groupdesc)
	{
		$servicesandgroups[_Group()]["group!$groupname"]=$groupdesc."]";
	}
	foreach ($servicetmp as $service=>$servicedesc)
	{
		$servicesandgroups[_Service()]["service!$service"]=$servicedesc;
	}


	// Select destination service
	SelectGrouped("new_dstserviceandtype",$servicesandgroups,$errors,"",1);
	echo "<a href='editservice.php'> "._New()."</a>";
	echo "</tr></table>";


	echo "<p>";
	echo "<table class='ctrlgroup'><tr><td>";

	// Select source
	echo _From()." ";
	Select("new_srctype",$src_hosttypes,$errors,"",1);
	echo "<td>";
	if ($new_srctype=="ipblock")
	{
		Select("new_src",$ipblocksselect,$errors,"",1);
	}
	elseif (($new_srctype=="hostname")||($new_srctype=="ipadress"))
	{
		InputText("new_src",$errors);
	}
	elseif ($new_srctype=="bridgeport")
	{
		Select("new_src",$bridgeportselect,$errors,"",1);
	}
	elseif ($new_srctype=="mac_adres")
	{
		InputText("new_src",$errors);
	}
	elseif ($new_srctype=="openvpn_cert")
	{
		Select("new_src",$openvpnselect,$errors,"",1);
	}
	echo "</tr></table>";

	// Select destination (only for forward mode)
	if ($mode=="forward")
	{
		//no Macadres in output chain
		echo "<p>";
		echo "<table class='ctrlgroup'><tr><td>";
		echo _To()." ";
		//disabled if srctype is zone_inet!
		Select("new_dsttype",$dst_hosttypes,$errors,"",1,$new_srctype!="zone_INET") ;
		echo "<td>";
		if ($new_dsttype=="ipblock")
		{
			Select("new_dst",$ipblocksselect,$errors,"",1);
		}
		elseif (($new_dsttype=="hostname")||($new_dsttype=="ipadress"))
		{
			InputText("new_dst",$errors);
		}
		elseif ($new_dsttype=="bridgeport")
		{
			Select("new_dst",$bridgeportselect,$errors,"",1);
		}
		elseif ($new_dsttype=="openvpn_cert")
		{
			Select("new_dst",$openvpnselect,$errors,"",1);
		}
		echo "</tr></table>";
		//Matching on output bridge ports works only if the packet is BRIDGED and not routed!
		//Warn the user for this
		if ($new_dsttype=="bridgeport" && $new_srctype!="bridgeport")
		{
			echo "<b>"._WarnDstBridgeportOnlyWorksWithBridgedTraffic()."</b>";
		}
	}



	// Select access or port adress translation
	echo "<p>";
	echo "<table class='ctrlgroup'><tr><td>";
	Select("new_access",$allowed_accessmodes,$errors,"",1);
	if ($new_access=="pat")
	{
		echo " "._IpAdress().":";
		InputText("new_fwdhost",$errors);
		echo " "._PortNumber().":";
		//for PAT we need to check extra stuff

		//Strip port range from selected service.
		list($dstservicetype,$dstservice)=explode("!",$new_dstserviceandtype);
		list($port,$proto)=explode("/",$dstservice);
		list($port,$toport)=explode("-",$port);

		$availableportrangeservices=getAvailablePatRanges($new_dstserviceandtype);

		//IF a portrange is selected at srctype the destination must also be a portrange.
		if($toport!="")
			Select("new_fwdports",$availableportrangeservices,$errors,"",1);
		else
			InputText("new_fwdport",$errors,'',1,5);
	}

	echo "</tr></table>";

	echo "<p>";
	Button("save",_Save(),"");
	//Button("del",_Del(),_ConfirmDeleteFirewallRule(HumanReadableRule($rulearray)),$ruletxt!="");
FormEnd();
Comment($ruletxt);


if ($iptableserror)
{
	echo "<p class='errormsg'>";
	echo $iptableserror;
	echo "</p>";
	echo "<p>";
	echo _ThereWasAnError();
	echo "</p>";
}


Foot();
