<?

	$CONF_FIREWALL_DIR="/etc/firewall";
	require_once("../common.php");
	require_once("services.php");
	require_once("iptables.php");
	$CONF_FIREWALL="$CONF_FIREWALL_DIR/firewall";
	$CONF_ADMINS="$CONF_FIREWALL_DIR/admins";

 	$ACCESSMODES=array(
		"allow"=>_AllowAccess(),
		"deny"=>_DenyAccess(),
		"pat"=>_ForwardTrafficTo()
	);

	$HOSTTYPES=array(
		"hostname"=>_Hostname(),
		"ipadress"=>_IpAdress(),
#		"localdns"=>_LocalDnsname(),
		"ipblock"=>_IpBlock(),
		"zone_IPSEC"=>_ZoneIPSEC(),
		"zone_PPTP"	=>_ZoneWindowsVPN(),
		"zone_LAN"	=>_ZoneLAN(),
		"zone_DMZ"	=>_ZoneDMZ(),
		"zone_INET"	=>_ZoneINET(),
		"zone_extra1"	=>_ZoneExtra1(),
		"zone_extra2"	=>_ZoneExtra2(),
		"zone_extra3"	=>_ZoneExtra3(),
		"zone_FW"	=>_ZoneFirewall(),
		"mac_adres"	=>_MacAdress(),
		"bridgeport"	=>_Bridgeport(),
		"openvpn_cert"	=>_OpenvpnCertificate(),
	);


	$SERVICES=services_Read();

	$ADMIN_IPS=ReadAdminIPs();
	UpdateAdminIP($_SERVER["REMOTE_ADDR"]);

	firewall_ConvOldfileformat();

/*
	$rulearray[srctype],    one of $HOSTTYPE
	$rulearray[src],		depends on choosen srctype (host or ipblock-name)
	$rulearray[dsttype] 	one of $HOSTTYPE
	$rulearray[dst],		depepds on choosen dsttype (host or ipblock-name)
	$rulearray[dstservice], one of $SERVICES: port/proto like 22/tcp
	$rulearray[access]		one of $ACCESSMODE (allow or deny or pat)
	$rulearray[fwdhost]		in case of pat
	$rulearray[fwdport]		in case of pat

*/

	/** Convert old comma seperated format to new config file
	*/
	function firewall_ConvOldfileformat()
	{
		global $CONF_FIREWALL;
		$raw=FileRead($CONF_FIREWALL);

		if (strstr($raw[0],"array"))
			return;

		$rules=array();
		foreach ($raw as $ruletxt)
		{
			$rulearray=array();
			if ($ruletxt[0]=="#")
			{
				$rulearray[enabled]=0;
				$ruletxt=ltrim($ruletxt,"#");
			}
			else
				$rulearray[enabled]=1;

			list(
				$rulearray[srctype],
				$rulearray[src],
				$rulearray[dsttype],
				$rulearray[dst],
				$rulearray[dstservicetype],
				$rulearray[dstservice],
				$rulearray[access],
				$rulearray[fwdhost],
				$rulearray[fwdport]
			)=explode(",",$ruletxt);

			if ($rulearray[dstservice]=="all")
				$rulearray[dstservice]="/";

			$rules[]=$rulearray;

			end($rules);
			Comment_rename($ruletxt,key($rules));
		}
		firewall_Write($rules);
	}

	function firewall_Write($rules)
	{

		global $CONF_FIREWALL;
		FileExport($CONF_FIREWALL,$rules);
	}


	function ReadAdminIPs()
	{
		global $CONF_ADMINS;
		return(FileRead($CONF_ADMINS,1,1));
	}

	//checks if the currently connect IP adress should be added to the admin ips
	function UpdateAdminIP($ip)
	{
		global $ADMIN_IPS;

		if (!$ip)
		{
			return;
		}
		if (!isset($ADMIN_IPS[$ip]))
		{
			$ADMIN_IPS[$ip]=1;
			WriteAdminIPs($ADMIN_IPS);
			LogWarn(_LogYourIpIsAddedToAdmins($ip));
		}
	}

	function WriteAdminIPs($ips)
	{
		global $CONF_ADMINS;
		$ret=(FileWrite($CONF_ADMINS,$ips,1));

		global $ADMIN_IPS;
		$ADMIN_IPS=ReadAdminIPs();

		IptablesSetAdminIps($ADMIN_IPS);

		return ($ret);
	}

	//sort callback for firewall_read (see below)
	//this will take care of sorting the rules
	function firewall_SortCallback($a, $b)
	{
		global $SERVICES;
		$ret=0;
		if ($ret==0)
		{
			$order=array(
				"pat"=>0,
				"deny"=>1,
				"allow"=>2
			);
			$ret=($order[$a[access]]-$order[$b[access]]);
		}
		if ($ret==0)
		{
			if ($a[dstservicetype]=='group')
				$atxt=$a[dstservice];
			if ($b[dstservicetype]=='group')
				$btxt=$b[dstservice];
			if ($a[dstservicetype]=='service')
				$atxt=$SERVICES[$a[dstservice]][desc];
			if ($b[dstservicetype]=='service')
				$btxt=$SERVICES[$b[dstservice]][desc];
			$ret=strcasecmp($atxt, $btxt);
		}
		if ($ret==0)
			$ret=strcasecmp($a[srctype], $b[srctype]);
		if ($ret==0)
			$ret=strcasecmp($a[src], $b[src]);
		if ($ret==0)
			$ret=strcasecmp($a[dsttype], $b[dsttype]);
		if ($ret==0)
			$ret=strcasecmp($a[dst], $b[dst]);
		return $ret;
	}

	//returns all the rules, with pat and blocking rules first
	function firewall_Read()
	{
		global $CONF_FIREWALL;
		$rules=FileImport($CONF_FIREWALL);
		uasort($rules,"firewall_SortCallback");
		return ($rules);
	}

	//changes rules with the specified rule-arrays.
	//-deletes the rule if newrule is false
	//-adds a rule if oldrule is false
	//-replaces a rule if both are specified
	function ChangeRule($oldid,$newrule)
	{
		global $CONF_FIREWALL;

		//cleanup the rule a bit
		if (strstr($newrule[dsttype],"zone_"))
		{
			$newrule[dst]="";
		}
		if (strstr($newrule[srctype],"zone_"))
		{
			$newrule[src]="";
		}

		UpdateOpenVPNIpsets();
		$rules=firewall_Read();

		if (!isset($newrule))
		{
			//delete old rule
			$oldrule=$rules[$oldid];
			unset($rules[$oldid]);
			$log=_LogDeletedFirewallRule(HumanReadableRule($oldrule));
		}
		elseif (isset($oldid))
		{
			//replace old rule
			$oldrule=$rules[$oldid];

			//no change
			if (!array_diff_assoc($newrule, $oldrule))
				return;

			$rules[$oldid]=$newrule;
			$id=$oldid;
			if ($oldrule[enabled]==$newrule[enabled])
				$log=_LogChangedFirewallRule(HumanReadableRule($oldrule),HumanReadableRule($newrule));
			else
			{
				if ($newrule[enabled])
					$log=_LogEnabledFirewallRule(HumanReadableRule($newrule));
				else
					$log=_LogDisabledFirewallRule(HumanReadableRule($newrule));
			}
		}
		else
		{
			//add new rule
			$rules[]=$newrule;
			end($rules);
			$id=key($rules);
			$log=_LogAddedFirewallRule(HumanReadableRule($newrule));
		}

		//store the new config
		firewall_Write($rules);

		//call iptables backend
		$err=IptablesChangeRule($oldrule,$newrule, $id);

		//change any existing comment
		Comment_rename($oldid,$id);

		//log after everything is fixed
		LogInfo($log);
	}

	/** This is called if user has renamed or added a service
	 */
	function firewall_ChangeService($oldid, $newid)
	{
		global $SERVICES;
		$SERVICES=services_Read();
		if ($oldid && $newid)
		{
			$rules=firewall_Read();
			foreach ($rules as $ruleid=>$rule)
			{
				if ($rule[dstservice]==$oldid)
				{
					$newrule=$rule;
					$newrule[dstservice]=$newid;
					ChangeRule($ruleid,$newrule);
				}
			}
		}
		IptablesRestart();
	}

	function getAvailablePatRanges($service)
	{
		global $PROTOS;
		list($type,$other)=explode("!",$service);
		list($ports,$protocol)=explode("/",$other);
		list($port,$toport)=explode("-",$ports);
		$rangewidth=$toport-$port;

		$services=services_Read();

		foreach($services as $nservice=>$data)
		{
			///FIXME: niet exploden, maar de inhoud van de $data array gebruiken, deze bevat ook een port en toport!
			list($nports,$nprotocol)=explode("/",$nservice);
			list($nport,$ntoport)=explode("-",$nports);

			if($ntoport-$nport==$rangewidth && $nprotocol==$protocol)
				$nservices["$nport-$ntoport"]=$data[desc]." [ $nport-$ntoport/".$PROTOS[$protocol]." ]";
		}
		return $nservices;
	}

	function HumanReadableRule($rulearray)
	{
		global $SERVICES;
		global $ACCESSMODES;
		global $HOSTTYPES;
		if ($rulearray[dstservicetype]=='service')
		{
			$dstservice_txt=$SERVICES[$rulearray[dstservice]][desc];
		}
		elseif ($rulearray[dstservicetype]=='group')
		{
			$dstservice_txt=_Group().": ".$rulearray[dstservice];
		}

		//no definition found anymore?
		if (!$dstservice_txt)
		{
			$dstservice_txt="$rulearray[dstservice] (?)";
		}

		if ($rulearray[access]=="pat")
		{
			$fwd=$rulearray[fwdhost].":".$rulearray[fwdport];
		}

		return _HumanReadableRule(
			$dstservice_txt,
			$HOSTTYPES[$rulearray[srctype]],
			$rulearray[src],
			$HOSTTYPES[$rulearray[dsttype]],
			$rulearray[dst],
			$ACCESSMODES[$rulearray[access]],
			$fwd
		);
	}

	/** Geeft hasharray-lijst van alle bridges en hun poorten
	 *
	 * $ret[eth0.0]="description";
	 *
	 * Momenteel gebruikt in bridging firewall
	 */
	function GetBridges()
	{
		$bridges=SafeExec("cd /sys/class/net;echo */brif/*;exit 0");
		$bridges=explode(" ",$bridges[0]);
		foreach ($bridges as $bridge)
		{
			list($name,$bla,$port)=explode("/",$bridge);
			$ret[$port]="$port ($name)";

		}
		natcasesort($ret);
		return $ret;
	}

	/* Get list of active openvpn certificates, for selectbox  */
	function GetOpenVPNCerts()
	{
		require_once("../openvpn/model.php");
		$certs=openvpn_List();
		foreach ($certs as $cert=>$status)
		{
			if ($status=="V")
				$ret[$cert]="$cert";
		}
		return($ret);

	}

	/* Make sure all openvpn ipsets exist */
	function UpdateOpenVPNIpsets()
	{

		require_once("../openvpn/model.php");
		$certs=openvpn_List();
		Cmd("ipset list -n|grep ^openvpn_cert", "", $existing_certs);
		foreach ($certs as $cert=>$status)
		{
			if ($status=="V" && !in_array("openvpn_cert_$cert", $existing_certs))
			{
				SafeExec("ipset create openvpn_cert_$cert hash:ip");
			}
		}
	}
